using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Org.Shokai.Skype
{
    public partial class SkypeAPIControlPanel : SkypePad.SkypeBridge
    {

        public SkypeAPIControlPanel()
        {
            InitializeComponent();
        }

        #region Property and Accessor

        private Boolean isConnect;
        public Boolean IsConnect
        {
            get
            {
                return isConnect;
            }
        }

        #endregion


        #region Method

        private void Trace(String str)
        {
            Console.WriteLine(str);
            textBoxLog.Text = str + "\r\n" + textBoxLog.Text;
        }

        public void Connect()
        {
            ConnectToSkype(); // ڑ
        }

        public void SendMessage(String message)
        {
            SendSkypeMessage(message);
            Trace(message);
        }

        #endregion

        #region UI Event

        private void buttonSendCommand_Click(object sender, EventArgs e)
        {
            SendMessage(textBoxSendCommand.Text);
            textBoxSendCommand.Text = "";
        }

        private void textBoxSendCommand_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SendMessage(textBoxSendCommand.Text);
                textBoxSendCommand.Text = "";
            }
        }

        private void buttonConnectAPI_Click(object sender, EventArgs e)
        {
            Connect();
        }

        #endregion
        
        #region Skype API Event

        // SkypeƐڑł
        protected override void OnConnectToSkype(int status)
        {
            Trace("---Skype API Connected!!---");
            isConnect = true;
            buttonConnectAPI.Enabled = false;
        }


        // Skype烁bZ[WĂۂ̃nh
        protected override void OnSkypeMessage(string message)
        {
            Trace("> " + message);
        }

        #endregion

    }
}