using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace SkypePad
{
    public partial class SkypeBridge : Form
    {
        ////// Win32 API @߂̐錾 ////////////////////////////////////////////
        ////// 萔
        private const UInt32 WM_COPYDATA = 0x004A;
        private IntPtr HWND_BROADCAST = (IntPtr)0xffff;

        protected const UInt32 ATTACH_SUCCESS = 0;
        protected const UInt32 ATTACH_PENDING_AUTHORIZATION = 1;
        protected const UInt32 ATTACH_REFUSED = 2;
        protected const UInt32 ATTACH_NOT_AVAILABLE = 3;
        protected const UInt32 ATTACH_API_AVAILABLE = 0x8001;

        ////// \
        [StructLayout(LayoutKind.Sequential)]
        private struct COPYDATASTRUCT
        {
            public int dwData;
            public int cbData;
            public IntPtr lpData;
        }

        ////// ֐
        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern uint RegisterWindowMessage(string lpString);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        ////// tH[̃CX^Xϐ ////////////////////////////////////

        // o^WindwosMessageۑp
        private uint WM_SKYPECONTROL_DISCOVER;
        private uint WM_SKYPECONTROL_ATTACH;

        // SkypeWindownh
        protected IntPtr hWndSkype = (IntPtr)0;

        ////// tH[̃\bh ////////////////////////////////////////////

        // RXgN^
        public SkypeBridge()
        {
            InitializeComponent();
            // Skype ƘAg邽߂̃bZ[Wo^Ă
            WM_SKYPECONTROL_DISCOVER = RegisterWindowMessage("SkypeControlAPIDiscover");
            WM_SKYPECONTROL_ATTACH = RegisterWindowMessage("SkypeControlAPIAttach");
        }

        // WindowvVW[I[o[Ch
        protected override void WndProc(ref Message m)
        {

            // KNXWndProc()ĂяoĂ
            base.WndProc(ref m);

            if ((UInt32)m.Msg == WM_SKYPECONTROL_ATTACH && hWndSkype == (IntPtr)0)
            {
                // Skype̐ڑX|Xڑ̏ꍇ

                // X|XR[hHď
                if (m.LParam == (IntPtr)0)
                {
                    // ڑOK̏ꍇ

                    // SkypẽEChEnhۑ
                    hWndSkype = m.WParam;

                    // Ƃ肠o[WT錾Ă
                    SendSkypeMessage("PROTOCOL 5");
                }

                OnConnectToSkype((int)m.LParam);
                // 1 Ԃ
                m.Result = (IntPtr)1;

            }
            else if ((UInt32)m.Msg == WM_COPYDATA && m.WParam == hWndSkype)
            {
                // SkypeWM_COPYDATȀꍇ

                // ƂɂCOPYDATASTRUCT\̂UnmanagedManaged
                COPYDATASTRUCT cds = (COPYDATASTRUCT)Marshal.PtrToStructure(m.LParam, typeof(COPYDATASTRUCT));

                // f[^UnmanagedManaged(Ō\0͕ϊȂ)
                byte[] bytes = new byte[cds.cbData - 1];
                Marshal.Copy(cds.lpData, bytes, 0, cds.cbData - 1);
                // UTF8oCg -> Unicode String
                string message = Encoding.UTF8.GetString(bytes);

                // nhĂяo
                OnSkypeMessage(message);

                // 1 Ԃ
                m.Result = (IntPtr)1;
            }
        }

        // SkypeɃbZ[W𑗂郆[eBeB
        protected void SendSkypeMessage(string message)
        {

            // SkypeƐڑĂ邩`FbN
            if (hWndSkype != (IntPtr)0)
            {
                // ڑĂꍇ

                // NULL^[~l[gUnicode stringUTF8oCg֕ϊ
                byte[] bytes = Encoding.UTF8.GetBytes(message + "\0");

                // UTF-8oCgUnmanaged -> Managed
                COPYDATASTRUCT cds;
                cds.dwData = 0;
                cds.lpData = Marshal.AllocCoTaskMem(bytes.Length);
                Marshal.Copy(bytes, 0, cds.lpData, bytes.Length);
                cds.cbData = bytes.Length;

                // COPYDATASTRUCT\̂Managed
                IntPtr ptr = Marshal.AllocCoTaskMem(Marshal.SizeOf(cds));
                Marshal.StructureToPtr(cds, ptr, true);

                // Skype փbZ[WM
                SendMessage(hWndSkype, WM_COPYDATA, this.Handle, ptr);

                // A}l[WhpɊ蓖Ă
                Marshal.FreeCoTaskMem(ptr);
                Marshal.FreeCoTaskMem(cds.lpData);
            }
        }

        // Skype ֐ڑ
        protected void ConnectToSkype()
        {
            // SkypeobZ[Wu[hLXg
            PostMessage(HWND_BROADCAST, WM_SKYPECONTROL_DISCOVER, this.Handle, (IntPtr)0);
        }

        // SkypeƐڑłۂ̃nh
        protected virtual void OnConnectToSkype(int status)
        {
            // Ȃ
        }

        // Skype烁bZ[WĂۂ̃nh
        protected virtual void OnSkypeMessage(string message)
        {

            // Ƃ肠R\[֏o
            Console.WriteLine(message);

        }

        private void SkypeBridge_Load(object sender, EventArgs e)
        {

        }
    }
}